<?php //ウイジェット用の関数

///////////////////////////////////////////////////
//Simplicityウイジェットの追加
//参考：WordPressのウィジェットを自作するためのTips - かちびと.net
//http://kachibito.net/wordpress/custom/how-to-add-your-widget.html
///////////////////////////////////////////////////
class SimplicityWidgetItem extends WP_Widget {
	function SimplicityWidgetItem() {
    	parent::WP_Widget(false, $name = 'Simplicity新着・人気エントリー');
    }
    function widget($args, $instance) {
        extract( $args );
        $title_new = apply_filters( 'widget_title_new', $instance['title_new'] );
        $title_popular = apply_filters( 'widget_title_popular', $instance['title_popular'] );
        //表示数を取得
        $entry_count = apply_filters( 'widget_entry_count', $instance['entry_count'] );
        $is_not_views_visible = apply_filters( 'widget_is_not_views_visible', $instance['is_not_views_visible'] );
        $range = apply_filters( 'range', $instance['range'] );
        $range_visible = apply_filters( 'range_visible', $instance['range_visible'] );
        //表示数をグローバル変数に格納
        //後で使用するテンプレートファイルへの受け渡し
        global $g_entry_count;
        //表示数が設定されていない時は5にする
        $g_entry_count = ($entry_count ? $entry_count : 5);
        global $g_is_views_visible;
        $g_is_views_visible = !$is_not_views_visible;
        global $g_range;
        $g_range = ($range ? $range : 'all');
        global $g_widget_item;
        $g_widget_item = 'SimplicityWidgetItem';
    	?>
          <?php if (is_home()) { //メインページの場合?>
            <div id="popular-entries" class="widget widget_new_popular">
              <h4><?php if ($title_popular) {
                echo $title_popular;
              } else {
                echo '人気エントリー';
              }
                ?></h4>
            <?php if (function_exists('wpp_get_mostpopular') && //Wordpress Popular Postsがインストールされているかどうか
                      is_wpp_enable()) { //Wordpress Popular Postsを?>
              <?php get_template_part('popular-posts-entries'); //PV順?>
              <?php if ($range_visible) {
                echo get_range_tag($range);
              } ?>
            <?php } else { //Wordpress Popular Postsがインストールされていない?>
              <?php get_template_part('popular-entries'); //コメント順?>
            <?php } ?>
            </div>
          <?php } else { //メインページ以外?>
            <div id="new-entries" class="widget widget_new_popular">
              <h4><?php if ($title_new) {
                echo $title_new;
              } else {
                echo '新着エントリー';
              }
                ?></h4>
              <?php get_template_part('new-entries'); ?>
            </div><!-- /#new-entries -->
          <?php } ?>
        <?php
    }
    function update($new_instance, $old_instance) {
      $instance = $old_instance;
      $instance['title_new'] = strip_tags($new_instance['title_new']);
      $instance['title_popular'] = trim($new_instance['title_popular']);
      $instance['entry_count'] = strip_tags($new_instance['entry_count']);
      $instance['is_not_views_visible'] = strip_tags($new_instance['is_not_views_visible']);
      $instance['range'] = strip_tags($new_instance['range']);
      $instance['range_visible'] = $new_instance['range_visible'];
        return $instance;
    }
    function form($instance) {
        $title_new = esc_attr($instance['title_new']);
        $title_popular = esc_attr($instance['title_popular']);
        $entry_count = esc_attr($instance['entry_count']);
        $is_not_views_visible = esc_attr($instance['is_not_views_visible']);
        $range = esc_attr($instance['range']);
        $range_visible = esc_attr($instance['range_visible']);
        ?>
        <p>
          <label for="<?php echo $this->get_field_id('title_new'); ?>">
          <?php echo('新着エントリーのタイトル'); ?>
          </label>
          <input class="widefat" id="<?php echo $this->get_field_id('title_new'); ?>" name="<?php echo $this->get_field_name('title_new'); ?>" type="text" value="<?php echo $title_new; ?>" />
        </p>

        <p>
           <label for="<?php echo $this->get_field_id('title_popular'); ?>">
           <?php echo('人気エントリーのタイトル'); ?>
           </label>
           <input class="widefat" id="<?php echo $this->get_field_id('title_popular'); ?>" name="<?php echo $this->get_field_name('title_popular'); ?>" type="text" value="<?php echo $title_popular; ?>" />
        </p>
        <?php //表示数入力フォーム ?>
        <p>
          <label for="<?php echo $this->get_field_id('entry_count'); ?>">
          <?php echo('表示数（半角数字、デフォルト：5）'); ?>
          </label>
          <input class="widefat" id="<?php echo $this->get_field_id('entry_count'); ?>" name="<?php echo $this->get_field_name('entry_count'); ?>" type="text" value="<?php echo $entry_count; ?>" />
        </p>
        <?php //集計単位の指定 ?>
        <p>
          <label for="<?php echo $this->get_field_id('range'); ?>">
          <?php echo('集計単位（Popular Posts）'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="daily"<?php echo ($range == 'daily' ? ' checked="checked"' : ''); ?> />1日<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="weekly"<?php echo ($range == 'weekly' ? ' checked="checked"' : ''); ?> />1週間<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="monthly"<?php echo ($range == 'monthly' ? ' checked="checked"' : ''); ?> />1ヶ月<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="all"<?php echo ($range == null || $range == 'all' ? ' checked="checked"' : ''); ?> />全期間<br />
        </p>
        <?php //集計単位の表示 ?>
        <p>
          <label for="<?php echo $this->get_field_id('range_visible'); ?>">
          <?php echo('集計期間の表示（Popular Posts）'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('range_visible'); ?>" name="<?php echo $this->get_field_name('range_visible'); ?>" type="checkbox" value="on"<?php echo ($range_visible ? ' checked="checked"' : ''); ?> />集計単位の表示
        </p>
        <?php //閲覧数の表示 ?>
        <p>
          <label for="<?php echo $this->get_field_id('is_not_top_visible'); ?>">
          <?php echo('閲覧数の表示（Popular Posts）'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('is_not_views_visible'); ?>" name="<?php echo $this->get_field_name('is_not_views_visible'); ?>" type="checkbox" value="on"<?php echo ($is_not_views_visible ? ' checked="checked"' : ''); ?> />閲覧数の非表示
        </p>
        <?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("SimplicityWidgetItem");'));

///////////////////////////////////////////////////
//新着エントリーウイジェットの追加
///////////////////////////////////////////////////
class SimplicityNewEntryWidgetItem extends WP_Widget {
     function SimplicityNewEntryWidgetItem() {
         parent::WP_Widget(false, $name = 'Simplicity新着エントリー');//ウイジェット名
    }
    function widget($args, $instance) {
        extract( $args );
        //タイトル名を取得
        $title_new = apply_filters( 'widget_title_new', $instance['title_new'] );
        //表示数を取得
        $entry_count = apply_filters( 'widget_entry_count', $instance['entry_count'] );
        $is_not_top_visible = apply_filters( 'widget_is_not_top_visible', $instance['is_not_top_visible'] );
        //表示数をグローバル変数に格納
        //後で使用するテンプレートファイルへの受け渡し
        global $g_entry_count;
        //表示数が設定されていない時は5にする
        $g_entry_count = ($entry_count ? $entry_count : 5);
         ?>
        <?php //classにwidgetと一意となるクラス名を追加する ?>
        <?php if ( !$is_not_top_visible || !is_home() ): ?>
        <div id="new-entries" class="widget widget_new_popular">
          <h4><?php if ($title_new) {
            echo $title_new;//タイトルが設定されている場合は使用する
          } else {
            echo '新着エントリー';
          }
            ?></h4>
          <?php
            //新着エントリー表示用の処理を書くところだけど
            //コード量も多く、インデントが深くなり読みづらくなるので
            //テンプレートファイル側に書く
            get_template_part('new-entries'); ?>
        </div><!-- /#new-entries -->
        <?php endif; ?>
      <?php
    }
    function update($new_instance, $old_instance) {
     $instance = $old_instance;
     $instance['title_new'] = strip_tags($new_instance['title_new']);
     $instance['entry_count'] = strip_tags($new_instance['entry_count']);
     $instance['is_not_top_visible'] = strip_tags($new_instance['is_not_top_visible']);
        return $instance;
    }
    function form($instance) {
        $title_new = esc_attr($instance['title_new']);
        $entry_count = esc_attr($instance['entry_count']);
        $is_not_top_visible = esc_attr($instance['is_not_top_visible']);
        ?>
        <?php //タイトル入力フォーム ?>
        <p>
          <label for="<?php echo $this->get_field_id('title_new'); ?>">
          <?php echo('新着エントリーのタイトル'); ?>
          </label>
          <input class="widefat" id="<?php echo $this->get_field_id('title_new'); ?>" name="<?php echo $this->get_field_name('title_new'); ?>" type="text" value="<?php echo $title_new; ?>" />
        </p>
        <?php //表示数入力フォーム ?>
        <p>
          <label for="<?php echo $this->get_field_id('entry_count'); ?>">
          <?php echo('表示数（半角数字、デフォルト：5）'); ?>
          </label>
          <input class="widefat" id="<?php echo $this->get_field_id('entry_count'); ?>" name="<?php echo $this->get_field_name('entry_count'); ?>" type="text" value="<?php echo $entry_count; ?>" />
        </p>
        <?php //TOPページ表示 ?>
        <p>
          <label for="<?php echo $this->get_field_id('is_not_top_visible'); ?>">
          <?php echo('トップページの表示'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('is_not_top_visible'); ?>" name="<?php echo $this->get_field_name('is_not_top_visible'); ?>" type="checkbox" value="on"<?php echo ($is_not_top_visible ? ' checked="checked"' : ''); ?> />非表示（トップは新着リストが表示されるため）
        </p>
        <?php
    }
}
add_action('widgets_init', create_function('', 'return register_widget("SimplicityNewEntryWidgetItem");'));

///////////////////////////////////////////////////
//カテゴリごとのPopular Postsウイジェットの追加
///////////////////////////////////////////////////
class SimplicityPopularPostsCategoryWidgetItem extends WP_Widget {
	function SimplicityPopularPostsCategoryWidgetItem() {
    	parent::WP_Widget(false, $name = 'Simplicityカテゴリー別人気エントリー');
    }
    function widget($args, $instance) {
        extract( $args );
        $title_popular = apply_filters( 'widget_title_popular', $instance['title_popular'] );
        //表示数を取得
        $entry_count = apply_filters( 'widget_entry_count', $instance['entry_count'] );
        $is_not_views_visible = apply_filters( 'widget_is_not_views_visible', $instance['is_not_views_visible'] );
        $range = apply_filters( 'range', $instance['range'] );
        $range_visible = apply_filters( 'range_visible', $instance['range_visible'] );
        //表示数をグローバル変数に格納
        //後で使用するテンプレートファイルへの受け渡し
        global $g_entry_count;
        //表示数が設定されていない時は5にする
        $g_entry_count = ($entry_count ? $entry_count : 5);
        global $g_is_views_visible;
        $g_is_views_visible = !$is_not_views_visible;
        global $g_range;
        $g_range = ($range ? $range : 'all');
        global $g_widget_item;
        $g_widget_item = 'SimplicityPopularPostsCategoryWidgetItem';
    	?>
        <?php if ( is_single() || is_category() )://投稿ページとカテゴリーページのとき ?>
          <div id="popular-entries" class="widget widget_category_popular">
            <h4><?php if ($title_popular) {
              echo $title_popular;
            } else {
              echo 'カテゴリー別人気エントリー';
            }
              ?></h4>
            <?php get_template_part('popular-posts-entries'); //PV順?>
            <?php if ($range_visible) {
              echo get_range_tag($range);
            } ?>
          </div>
        <?php endif; ?>
    <?php
    }
    function update($new_instance, $old_instance) {
      $instance = $old_instance;
      $instance['title_popular'] = trim(strip_tags($new_instance['title_popular']));
      $instance['entry_count'] = strip_tags($new_instance['entry_count']);
      $instance['is_not_views_visible'] = $new_instance['is_not_views_visible'];
      $instance['range'] = $new_instance['range'];
      $instance['range_visible'] = $new_instance['range_visible'];
        return $instance;
    }
    function form($instance) {
        $title_popular = esc_attr($instance['title_popular']);
        $entry_count = esc_attr($instance['entry_count']);
        $is_not_views_visible = esc_attr($instance['is_not_views_visible']);
        $range = esc_attr($instance['range']);
        $range_visible = esc_attr($instance['range_visible']);
        ?>

        <p>
           <label for="<?php echo $this->get_field_id('title_popular'); ?>">
           <?php echo('人気エントリーのタイトル'); ?>
           </label>
           <input class="widefat" id="<?php echo $this->get_field_id('title_popular'); ?>" name="<?php echo $this->get_field_name('title_popular'); ?>" type="text" value="<?php echo $title_popular; ?>" />
        </p>
        <?php //表示数入力フォーム ?>
        <p>
          <label for="<?php echo $this->get_field_id('entry_count'); ?>">
          <?php echo('表示数（半角数字、デフォルト：5）'); ?>
          </label>
          <input class="widefat" id="<?php echo $this->get_field_id('entry_count'); ?>" name="<?php echo $this->get_field_name('entry_count'); ?>" type="text" value="<?php echo $entry_count; ?>" />
        </p>
        <?php //集計単位の指定 ?>
        <p>
          <label for="<?php echo $this->get_field_id('range'); ?>">
          <?php echo('集計単位'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="daily"<?php echo ($range == 'daily' ? ' checked="checked"' : ''); ?> />1日<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="weekly"<?php echo ($range == 'weekly' ? ' checked="checked"' : ''); ?> />1週間<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="monthly"<?php echo ($range == 'monthly' ? ' checked="checked"' : ''); ?> />1ヶ月<br />
          <input class="widefat" id="<?php echo $this->get_field_id('range'); ?>" name="<?php echo $this->get_field_name('range'); ?>" type="radio" value="all"<?php echo ($range == null || $range == 'all' ? ' checked="checked"' : ''); ?> />全期間<br />
        </p>
        <?php //集計単位の表示 ?>
        <p>
          <label for="<?php echo $this->get_field_id('range_visible'); ?>">
          <?php echo('集計期間の表示'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('range_visible'); ?>" name="<?php echo $this->get_field_name('range_visible'); ?>" type="checkbox" value="on"<?php echo ($range_visible ? ' checked="checked"' : ''); ?> />集計単位の表示
        </p>
        <?php //閲覧数の表示 ?>
        <p>
          <label for="<?php echo $this->get_field_id('is_not_top_visible'); ?>">
          <?php echo('閲覧数の表示'); ?>
          </label><br />
          <input class="widefat" id="<?php echo $this->get_field_id('is_not_views_visible'); ?>" name="<?php echo $this->get_field_name('is_not_views_visible'); ?>" type="checkbox" value="on"<?php echo ($is_not_views_visible ? ' checked="checked"' : ''); ?> />閲覧数の非表示
        </p>
        <?php
    }
}
//Wordpress Popular Postsがインストールされていない場合を表示しない
if ( function_exists('wpp_get_mostpopular') ):
  add_action('widgets_init', create_function('', 'return register_widget("SimplicityPopularPostsCategoryWidgetItem");'));
endif;

//集計単位の文字列取得
function get_range_tag($range){
  switch ($range) {
    case 'daily':
      return '<div class="wpp-range">（集計単位：1日）</div>';
      break;
    case 'weekly':
      return '<div class="wpp-range">（集計単位：1週間）</div>';
      break;
    case 'monthly':
      return '<div class="wpp-range">（集計単位：1ヶ月）</div>';
      break;
    default:
       return '<div class="wpp-range">（集計単位：全期間）</div>';
  }
}

